/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Manuel Leuenberger
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY


#include "power_up.h"
#include "extendable.h"
#include "primitive_model.h"

using namespace std;

Model* PowerUp::sphereModel = new PrimitiveModel(PRIM_SPHERE, 7, 5);

PowerUp::PowerUp(float r, float g, float b)
{
  this->sphereMaterial = new Material;
  this->sphereMaterial->setTransparency(.1);
  this->sphereMaterial->setDiffuse(r, g, b);
}

PowerUp::~PowerUp ()
{
  delete this->sphereMaterial;
}


void PowerUp::loadParams(const TiXmlElement* root)
{
  static_cast<WorldEntity*>(this)->loadParams(root);
}


void PowerUp::collidesWith (WorldEntity* entity, const Vector& location)
{
 if(entity->isA(CL_EXTENDABLE))
  {
    if(dynamic_cast<Extendable*>(entity)->pickup(this))
    {
      this->hide();
    }
  }
}

void PowerUp::hide()
{
  this->setVisibiliy(false);
}

void PowerUp::draw()
{
  WorldEntity::draw();
  this->sphereMaterial->select();
  sphereModel->draw();
}

